###

#

read_image_info.hpp
//
// Copyright 2007-2012 Christian Henning, Andreas Pokorny, Lubomir Bourdev
//
// Distributed under the Boost Software License, Version 1.0
// See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt
//
#ifndef BOOST_GIL_IO_READ_IMAGE_INFO_HPP
#define BOOST_GIL_IO_READ_IMAGE_INFO_HPP
#include <boost/gil/io/base.hpp>
#include <boost/gil/io/device.hpp>
#include <boost/gil/io/get_reader.hpp>
#include <boost/gil/io/path_spec.hpp>
#include <boost/gil/detail/mp11.hpp>
#include <type_traits>
namespace boost{ namespace gil {
template <typename Device, typename FormatTag>
inline
auto read_image_info(Device& file, image_read_settings<FormatTag> const& settings,
typename std::enable_if
<
mp11::mp_and
<
detail::is_adaptable_input_device<FormatTag, Device>,
is_format_tag<FormatTag>
>::value
>::type* /*dummy*/ = nullptr)
-> typename get_reader_backend<Device, FormatTag>::type
{
return make_reader_backend(file, settings);
}
template <typename Device, typename FormatTag>
inline
auto read_image_info(Device& file, FormatTag const&,
typename std::enable_if
<
mp11::mp_and
<
detail::is_adaptable_input_device<FormatTag, Device>,
is_format_tag<FormatTag>
>::value
>::type* /*dummy*/ = nullptr)
-> typename get_reader_backend<Device, FormatTag>::type
{
return read_image_info(file, image_read_settings<FormatTag>());
}
template <typename String, typename FormatTag>
inline
auto read_image_info(
String const& file_name, image_read_settings<FormatTag> const& settings,
typename std::enable_if
<
mp11::mp_and
<
is_format_tag<FormatTag>,
detail::is_supported_path_spec<String>
>::value
>::type* /*dummy*/ = nullptr)
-> typename get_reader_backend<String, FormatTag>::type
{
return make_reader_backend(file_name, settings);
}
template <typename String, typename FormatTag>
inline
auto read_image_info(String const& file_name, FormatTag const&,
typename std::enable_if
<
mp11::mp_and
<
is_format_tag<FormatTag>,
detail::is_supported_path_spec<String>
>::value
>::type* /*dummy*/ = nullptr)
-> typename get_reader_backend<String, FormatTag>::type
{
return read_image_info(file_name, image_read_settings<FormatTag>());
}
}} // namespace boost::gil
#endif
boost::gil::read_image_info
auto read_image_info(Device &file, image_read_settings< FormatTag > const &settings, typename std::enable_if< mp11::mp_and< detail::is_adaptable_input_device< FormatTag, Device >, is_format_tag< FormatTag > >::value >::type *=nullptr) -> typename get_reader_backend< Device, FormatTag >::type
Returns the image format backend. Backend is format specific.
Definition: read_image_info.hpp:30
boost
defined(BOOST_NO_CXX17_HDR_MEMORY_RESOURCE)
Definition: algorithm.hpp:36
boost::gil::get_reader_backend
Helper metafunction to generate image backend type.
Definition: get_reader.hpp:115